
// data base to set the expand controller automaticaly

ex_controller_type = EX_NONE;
tf_bank = 0;

// Mapper 000 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 0)
{
  if(sum_16k_rom() == 0x1c47e1 || // Family Basjc V1
     sum_16k_rom() == 0x1c5ba8 || // Family Basic V2
     sum_16k_rom() == 0x1c5ba8 || // Family Basic V2.1a
     sum_16k_rom() == 0x17d985 || // Family Basic V3
     sum_16k_rom() == 0x17da54)   // Family Basic V3 (Alt)
  {
    ex_controller_type = EX_FAMILY_KEYBOARD;
  }
  if(sum_16k_rom() == 0x1da4a4 || // Hyper Olympic
     sum_16k_rom() == 0x1e5600)   // Hyper Sports
  {
    ex_controller_type = EX_HYPER_SHOT;
  }
  if(sum_16k_rom() == 0x1d8261 || // Duck Hunt
     sum_16k_rom() == 0x1ee84a || // Hogan's Alley
     sum_16k_rom() == 0x1d1783)   // Wild Gunman
  {
    ex_controller_type = EX_OPTICAL_GUN;
  }
}

// Mapper 001 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 1)
{
  if(sum_16k_rom() == 0x22425c || // Adventures of Bayou Billy, The
     sum_16k_rom() == 0x2249c0 || // Adventures of Bayou Billy, The
     sum_16k_rom() == 0x1a2099 || // Barker Bill's Trick Shooting
     sum_16k_rom() == 0x12ebdb || // Freedom Force
     sum_16k_rom() == 0x1e2916 || // Mad City
     sum_16k_rom() == 0x10d1b2)   // Mechanized Attack
  {
    ex_controller_type = EX_OPTICAL_GUN;
  }
  if(sum_16k_rom() == 0x1b790d)   // Ide Yousuke Meijin No Jissen Mahjong 2
  {
    ex_controller_type = EX_MAHJONG;
  }
  if(sum_16k_rom() == 0x32e55f || // Dance Aerobics
     sum_16k_rom() == 0x1e7d1e || // Short Order - Eggsplode
     sum_16k_rom() == 0x1bbb52)   // Street Cop
  {
    ex_controller_type = EX_POWER_PAD_B;
  }
  if(sum_16k_rom() == 0x1c2871)   // Best Play - Pro Yakyuu
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 0;
  }
  if(sum_16k_rom() == 0x12d5d8)   // Best Play - Pro Yakyuu 2
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 1;
  }
  if(sum_16k_rom() == 0x12f098)   // Best Play - Pro Yalyuu '90
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 2;
  }
  if(sum_16k_rom() == 0x244249)   // Best Play - Pro Yakyuu Special
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 3;
  }
  if(sum_16k_rom() == 0x219a45)   // Derby Stallion - Zenkoku Ban
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 5;
  }
  if(sum_16k_rom() == 0x1a2c47)   // Dungeon Kid
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 7;
  }
  if(sum_16k_rom() == 0x24c562)   // Haja No Fuuin
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 9;
  }
  if(sum_16k_rom() == 0x1b4a84)   // Itadaki Street - Watashi no Mise ni Yottette
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 10;
  }
  if(sum_16k_rom() == 0x1733a3)   // Ninjara Hoi!
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 11;
  }
  if(sum_16k_rom() == 0x155b45)   // Wizardry - Proving Grounds of the Mad Overlord (J)
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 12;
  }
}

// Mapper 002 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 2)
{
  if(sum_16k_rom() == 0x14cbc5)   // Ide Yousuke Meijin No Jissen Mahjong
  {
    ex_controller_type = EX_MAHJONG;
  }
}

// Mapper 003 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 3)
{
  if(sum_16k_rom() == 0x156412)   // Arkanoid (J)
  {
    ex_controller_type = EX_ARKANOID_PADDLE;
  }
  if(sum_16k_rom() == 0x1a2970 || // Family Trainer - Athletic World
     sum_16k_rom() == 0x189e52 || // Family Trainer - Jogging Race
     sum_16k_rom() == 0x1a1a1d)   // Family Trainer - Rairai! Kyounshiizu
  {
    ex_controller_type = EX_FAMILY_TRAINER_A;
  }
  if(sum_16k_rom() == 0x1f1902 || // Family Trainer - Aerobics Studio
     sum_16k_rom() == 0x17e9ec || // Family Trainer - Dai Undoukai
     sum_16k_rom() == 0x30e3bc || // Family Trainer - Fuuun!! Takeshi Jou 2
     sum_16k_rom() == 0x187119 || // Family Trainer - Running Stadium
     sum_16k_rom() == 0x191009)   // Family Trainer - Totsugeki Fuuun Takeshi Jou
  {
    ex_controller_type = EX_FAMILY_TRAINER_B;
  }
  if(sum_16k_rom() == 0x14b5cc || // Gotcha!
     sum_16k_rom() == 0x158281)   // Shooting Range
  {
    ex_controller_type = EX_OPTICAL_GUN;
  }
  if(sum_16k_rom() == 0x1dc240)   // Super Mogura Tataki!! - Pokkun Moguraa
  {
    ex_controller_type = EX_POKKUN_MOGURAA;
  }
  if(sum_16k_rom() == 0x196cb2)   // Athletic World
  {
    ex_controller_type = EX_POWER_PAD_A;
  }
  if(sum_16k_rom() == 0x1728a9)   // Castle Excellent
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 4;
  }
  if(sum_16k_rom() == 0x18b8d0)   // Fleet Commander
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 8;
  }
}

// Mapper 004 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 4)
{
  if(sum_16k_rom() == 0x1b0c8e || // Lone Ranger, The
     sum_16k_rom() == 0x198105)   // To The Earth
  {
    ex_controller_type = EX_OPTICAL_GUN;
  }
  if(sum_16k_rom() == 0x16a9c3)   // Downtown - Nekketsu Monogatari
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 6;
  }
  if(sum_16k_rom() == 0x1be330 || // Wizardry - Legacy of Llylgamyn (J)
     sum_16k_rom() == 0x18a8e4)   // Wizardry - The Knight of Diamonds (J)
  {
    ex_controller_type = EX_TURBO_FILE;
    tf_bank = 12;
  }
}

// Mapper 005 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 5)
{
  if(sum_16k_rom() == 0x1a7ad9 || // Gun Sight
     sum_16k_rom() == 0x1a66dc)   // Laser Invasion
  {
    ex_controller_type = EX_OPTICAL_GUN;
  }
}

// Mapper 011 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 11)
{
  if(sum_16k_rom() == 0x1cb2b7 || // Baby Boomer
     sum_16k_rom() == 0x1c9610)   // Chiller
  {
    ex_controller_type = EX_OPTICAL_GUN;
  }
}

// Mapper 016 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 16)
{
  if(sum_16k_rom() == 0x1c41e1 || // Datach - Battle Rush - Build Up Robot Tournament
     sum_16k_rom() == 0x1a2976 || // Datach - Crayon Shin Chan - Ora to Poi Poi
     sum_16k_rom() == 0x2d57ab || // Datach - Dragon Ball Z - Gekitou Tenkaichi Budou Kai
     sum_16k_rom() == 0x14a891 || // Datach - J League Super Top Players
     sum_16k_rom() == 0x14dc0d || // Datach - SD Gundam - Gundam Wars
     sum_16k_rom() == 0x22bd56 || // Datach - Ultraman Club - Supokon Fight!
     sum_16k_rom() == 0x1740dc)   // Datach - Yuu Yuu Hakusho - Bakutou Ankoku Bujutsu Kai
  {
    ex_controller_type = EX_DATACH_BARCODE_BATTLER;
  }
}

// Mapper 066 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 66)
{
  if(sum_16k_rom() == 0x1ee6f8)   // Gumshoe
  {
    ex_controller_type = EX_OPTICAL_GUN;
  }
}

// Mapper 070 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 70)
{
  if(sum_16k_rom() == 0x2947ba)   // Arkanoid 2 (J)
  {
    ex_controller_type = EX_ARKANOID_PADDLE;
  }
  if(sum_16k_rom() == 0x18bcfa || // Family Trainer - Manhattan Police
     sum_16k_rom() == 0x1f3fd1)   // Family Trainer - Meiro Daisakusen
  {
    ex_controller_type = EX_FAMILY_TRAINER_B;
  }
  if(sum_16k_rom() == 0x15d81b)   // Space Shadow
  {
    ex_controller_type = EX_SPACE_SHADOW_GUN;
  }
}

// Mapper 075 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 75)
{
  if(sum_16k_rom() == 0x25f209)   // Exciting Boxing
  {
    ex_controller_type = EX_EXCITING_BOXING;
  }
}

// Mapper 087 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 87)
{
  if(sum_16k_rom() == 0x2dd610)   // Hyper Olympic - Tonosama Version
  {
    ex_controller_type = EX_HYPER_SHOT;
  }
}

// Mapper 096 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 96)
{
  ex_controller_type = EX_OEKAKIDS_TABLET;
}

// Mapper 099 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 99)
{
  if(sum_16k_rom() == 0x2265be || // VS Duck Hunt
     sum_16k_rom() == 0x257319)   // VS Hogan's Alley
  {
    ex_controller_type = EX_VS_ZAPPER;
  }
}

// Mapper 180 -----------------------------------------------------------------
if(ROM->get_mapper_num() == 180)
{
  if(sum_16k_rom() == 0x187325)   // Crazy Climber
  {
    ex_controller_type = EX_CRAZY_CLIMBER;
  }
}

